<?php
namespace nur\sery\file\csv;

use nur\sery\ValueException;

trait TAbstractBuilder {
  static function with($builder): self {
    if ($builder instanceof self) return $builder;
    elseif (is_string($builder)) return new static($builder);
    elseif (is_array($builder)) return new static(null, $builder);
    else throw ValueException::invalid_type($builder, self::class);
  }
}
